#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TelephoneBillDropCFG.h"
std::auto_ptr<Fish_TelephoneBillDropCFG> Fish_TelephoneBillDropCFG::msSingleton(nullptr);

int Fish_TelephoneBillDropCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TelephoneBillDropCFGData* Fish_TelephoneBillDropCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TelephoneBillDropCFGData>& Fish_TelephoneBillDropCFG::GetMapData()
{
	return mMapData;
}

void Fish_TelephoneBillDropCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TelephoneBillDropCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TelephoneBillDropCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mRechargeLimit = element->IntAttribute("RechargeLimit");
		{
			const char* HistoricalCharges = element->Attribute("HistoricalCharges");
			std::vector<std::string> vecHistoricalCharges;
			boost::split(vecHistoricalCharges, HistoricalCharges, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecHistoricalCharges.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecHistoricalCharges[i].c_str(), &temp))
				{
					data.mHistoricalCharges.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TelephoneBillDropCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TelephoneBillDropCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TelephoneBillDropCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TelephoneBillDropCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TelephoneBillDropCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "RechargeLimit", data.mRechargeLimit);
		LuaCfgHelper::readVectorInt(L, "HistoricalCharges", data.mHistoricalCharges);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TelephoneBillDropCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TelephoneBillDropCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TelephoneBillDropCFG* Fish_TelephoneBillDropCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TelephoneBillDropCFG());
	}
	return msSingleton.get();
}

void Fish_TelephoneBillDropCFG::Release()
{
	msSingleton.reset(nullptr);
}
